#include <vector>
#include <iostream>
#include<cmath>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t SCREEN_WIDTH{};
    size_t number_count{};

};

Input
input_data() {


Input in;
cerr << "Enter number count: ";
cin >> in.number_count;
in.numbers.resize(in.number_count);
 for (size_t i = 0; i < in.number_count; i++) {
        cin >> in.numbers[i];
    }
cerr<<"Enter bin count:";
cin >> in.bin_count;



     while (true) {
        cerr << "Screen width: ";
        cin >> in.SCREEN_WIDTH;
		if (in.SCREEN_WIDTH < 7) {
            cerr << "<7"; cerr << endl;
            continue;
		}
		if (in.SCREEN_WIDTH > 80) {
            cerr << ">80";  cerr << endl;
            continue;
		}

		if (in.SCREEN_WIDTH < (in.number_count / 3)){
            cerr << "<number_count/3";  cerr << endl;
            continue;
		}
        break;
	}
	return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}

std::vector<double>
make_histogram(const std::vector<double>& numbers, size_t bin_count) {
    vector<double> bins(bin_count);

    double min = 0, max = 0;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    for (int i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (int j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

int main()
{
    auto in = input_data();

    double min, max;

    find_minmax(in.numbers, min, max);



	const size_t MAX_ASTERISK = in.SCREEN_WIDTH - 3 - 1;



auto bins = make_histogram(in.numbers, in.bin_count);





	double mxbins = bins[0];

	for (double x : bins)
	{
		if (x > mxbins)
			mxbins = x;
	}
	double k;

	if (mxbins > MAX_ASTERISK)
		k = MAX_ASTERISK / mxbins;
	else
		k = 1;
	for (size_t i = 0; i < in.bin_count; i++)
	{
		if (bins[i] < 10) {
			cout << "  " << bins[i] << "|";
		}
		else if (bins[i] < 100) {
			cout << " " << bins[i] << "|";
		}
		else if (bins[i] < 1000) {
			cout << bins[i] << "|";

		}
		for (int j = 0; j < floor(bins[i] * k); j++)
		{
			cout << "*";
		}

		cout << endl;
	}
}

